/*****************************************************/
/*      Functions for ActDecide                      */
/*                                                   */
/*                         develop by Atsushi Ito    */
/*                       ver 2.1.1   Jan. 20 2009    */
/*****************************************************/


#include <stdio.h>
#include <stdlib.h>

#include "corporated.h"
#include "virtual.h"
#include "detail.h"

#define ER_MAX 100

extern int datail_area2();

int err_safe2(int e_cnt, int posi_cnt){
	int i,j,k;
	int err_num,err_area;
	char a_char[]={'A','B','C','D'};
	int dummy;
	int position;
	int num_safe[10];
	char zone_safe[10];
	
	// initialize
	
	for(i=0;i<DWIDTH;i++){
		check_num[i]=0;
		check_area[i]=0;
		dnot_count[i]=0;
		posi_dzone[i]=0;
		ranking[i]=0;
		zone_safe[i]=0;
	}
	
	err_num=0;
	err_area=0;
	dummy=0;
	
	// step 1 : check area
	
	for(i=0;i<POST_CNT;i++){
		if(pdata.num[i]>ER_MAX){
			num_safe[err_num]=i+1;
			err_num++;
		}else{
			check_num[pdata.num[i]-1]++;
		}
		
		if(pdata.dzone[i]>ER_MAX){
			err_area++;
		}else{
			check_area[pdata.dzone[i]]++;
		}
	}
	
	printf("post num : %d %d %d %d %d\n",check_num[0],check_num[1],check_num[2],check_num[3],check_num[4]);
	printf("detail area : %d %d %d %d %d %d %d %d\n",check_area[0],check_area[1],check_area[2],check_area[3],check_area[4],check_area[5],check_area[6],check_area[7]);
	
	// step 2 : check possible zone
	
	for(i=0;i<posi_cnt;i++){
		d_data.x[i]=fx[i];
		d_data.y[i]=fy[i];
		d_data.zone[i]=decide_area(d_data.x[i], d_data.y[i]);
		if(d_data.zone[i]=='A'){
			dnot_count[0]++;
		}else if(d_data.zone[i]=='B'){
			dnot_count[1]++;
		}else if(d_data.zone[i]=='C'){
			dnot_count[2]++;
		}else if(d_data.zone[i]=='D'){
			dnot_count[3]++;
		}else if(d_data.zone[i]=='Z'){
			dnot_count[4]++;
		}
	}
	printf("possible area count\n");
	printf("A	B	C	D\n");
	printf("%d	%d	%d	%d\n",dnot_count[0],dnot_count[1],dnot_count[2],dnot_count[3]);
	printf("check error : %d\n",dnot_count[4]);
	
	for(i=0;i<posi_cnt;i++){
		d_data.dzone[i]=analyzer_v2(i,d_data.x[i],d_data.y[i]);
		printf("%d\n",d_data.dzone[i]);
		posi_dzone[d_data.dzone[i]]++;
	}
	printf("possible detail area count\n");
	printf("0	1	2	3	4	5	6	7\n");
	printf("%d	%d	%d	%d	%d	%d	%d	%d\n",posi_dzone[0],posi_dzone[1],posi_dzone[2],posi_dzone[3],posi_dzone[4],posi_dzone[5],posi_dzone[6],posi_dzone[7]);
	
	
	// step 3 : ranking
	
	for(i=0;i<err_num;i++){
		dummy=0;
		position=0;
		for(j=0;j<DA_NUM;j++){
			if(dummy<posi_dzone[j]){
				dummy=posi_dzone[j];
				position=j;
			}
		}
		ranking[i]=position;
		posi_dzone[position]=0;
	}
	
	printf("safe number\n");
	for(i=0;i<err_num;i++){
		printf("%d	\n",num_safe[i]);
	}
	printf("\n");
	
	printf("safe detail area\n");
	for(i=0;i<err_num;i++){
		printf("%d	\n",ranking[i]);
	}
	printf("\n");
	
	for(i=0;i<err_num;i++){
		zone_safe[i]=detail_enc(ranking[i]);
	}
	
	// step 4 : error safe
	for(i=0;i<err_num;i++){
		printf("safe_num : %d , safe_area : %c, safe_datail_area : %d\n",num_safe[i],zone_safe[i],ranking[i]);
		pdata.num[num_safe[i]-1]=num_safe[i];
		pdata.zone[num_safe[i]-1]=zone_safe[i];
		pdata.dzone[num_safe[i]-1]=ranking[i];
		d_err[num_safe[i]-1]=1;
	}
	
	return 0;
}

int decide_area(int map_x, int map_y){
	int i;
	char area='z';
	int err=0;
	
	printf("analyzer initialize complete\n");
		
	if(map_x >= 0 && map_x <= 9 && map_y >= 0 && map_y <= 9){ //A
		area='A';
	}else if(map_x >= 10 && map_x <= 19 && map_y >= 0 && map_y <= 9){
		area='B';
	}else if(map_x >= 0 && map_x <= 9 && map_y >= 10 && map_y <= 19){
		area='C';
	}else if(map_x >= 10 && map_x <= 19 && map_y >= 10 && map_y <= 19){
		area='D';
	}else{
		area='Z';
		//err++;
	}
	
	printf("x = %d, y = %d, area = %c\n",map_x,map_y,area);
	
	return area;
}


int analyzer_v2(int i,int map_x, int map_y)
{
	int scan1,scan2;
	int d_area;
	int check_num;
	char area_mode1=0,area_mode2=0;
	int flag;
	
//	printf("post-%d area : %c\n",pdata.num[i],d_data.zone[i]);
	
	
	check_num=UNKNOWN;
	
	switch(d_data.zone[i]){
		case 'A':
			area_mode1='b';
			area_mode2='d';
			break;
		
		case 'B':
			area_mode1='f';
			area_mode2='h';
			break;
		
		case 'C':
			area_mode1='e';
			area_mode2='g';
			break;
		
		case 'D':
			area_mode1='a';
			area_mode2='c';
			break;
		
		default:
			printf("zone error !\n");
			flag=904;
			break;
	}
	
	if(flag==904){
		return 904;
	}
	
	scan1=detail_area2(check_num,area_mode1,map_x,map_y);
	scan2=detail_area2(check_num,area_mode2,map_x,map_y);
	if(scan1<SCAN_ERR && scan2>SCAN_ERR){
		d_area=scan1;
	}else if(scan1>SCAN_ERR && scan2<SCAN_ERR){
		d_area=scan2;
	}else{
		printf("area error !\n");
		d_area=SCAN_ERR;
	}
	
	//detail_area(50,'a');
	//detail_area(ASCN+pdata.num[i],'a');
	
	printf("\n");
	return d_area;
}

int detail_enc(int d_area){
	int area;
	
	switch(d_area){
		case 0:
			area='D';
			break;
		case 1:
			area='D';
			break;
		case 2:
			area='B';
			break;
		case 3:
			area='B';
			break;
		case 4:
			area='A';
			break;
		case 5:
			area='A';
			break;
		case 6:
			area='C';
			break;
		case 7:
			area='C';
		default:
			area='Z';
	}
	return area;
}
