/* virtual map */

#include <stdio.h>

#include "virtual.h"

int draw_zone(int width, int dc, char out){
	
	int xmin,xmax,ymin,ymax;
	int k,l;
	
	
	if(y[dc]<=width){
		ymin=0;
	}else{
		ymin=y[dc]-width;
	}
	
	if(y[dc]>=19-width){
		ymax=19;
	}else{
		ymax=y[dc]+width;
	}
	
	if(x[dc]<=DIS_W){
		xmin=0;
	}else{
		xmin=x[dc]-width;
	}
	
	if(x[dc]>=19-width){
		xmax=19;
	}else{
		xmax=x[dc]+width;
	}
	
	printf("xmin : %d, xmax : %d\n",xmin,xmax);
	printf("ymin : %d, ymax : %d\n",ymin,ymax);
	
	for(k=ymin;k<ymax+1;k++){
		for(l=xmin;l<xmax+1;l++){
			map[k][l]=out;
		}
	}
	
	
	return 0;
}


int virtual_map(void){
	int i,j;
	FILE *mf,*data;
	
	int dnum,ddir;
	double dx,dy;
	
	double rx[10],ry[10];
	
	char fname[]="map.txt";
	
	for(i=0;i<20;i++){
		for(j=0;j<20;j++){
			map[i][j]=DEFAULT;
		}
	}
	
	
	//phase1 : data input
	
	printf("phase1 : data input\n");
	if((data=fopen("data.txt","r"))==NULL){
		printf("data.txt cannot open !\n");
		exit(1);
	}
	
	i=0;
	printf("get post data\n");
	while((fscanf(data,"%d	%lf	%lf	%d",&dnum,&dx,&dy,&ddir))!=EOF){
		//fscanf(data,"%d	%d	%d	%d",&dnum,&dx,&dy,&ddir);
		num[i]=dnum;
		x[i]=dx;
		y[i]=dy;
		printf("%d	%d	%d\n",num[i],x[i],y[i]);
		i++;
	}
	fclose(data);
	data_count=i;
	
	
	printf("\n");
	//phase2 : x add
	
	printf("phase2 : x add\n");
	for(i=0;i<data_count;i++){
		x[i]+=1600;
		printf("%d	%d	%d\n",num[i],x[i],y[i]);
	}
	
	
	printf("\n");
	//phase3 : div
	
	printf("phase3 : div\n");
	for(i=0;i<data_count;i++){
		rx[i]=x[i]/160;
		ry[i]=y[i]/160;
		printf("%d	%f	%f\n",num[i],rx[i],ry[i]);
	}
	
	
	printf("\n");
	//phase4 : add
	
	printf("phase4 : add\n");
	for(i=0;i<data_count;i++){
		rx[i]+=0.5;
		ry[i]+=0.5;
		printf("%d	%f	%f\n",num[i],rx[i],ry[i]);
	}
	
	
	printf("\n");
	//phase5 : int
	
	printf("phase5 : int\n");
	for(i=0;i<data_count;i++){
		x[i]=rx[i];
		y[i]=ry[i];
		printf("%d	%d	%d\n",num[i],x[i],y[i]);
	}
	
	
	printf("\n");
	//phase6 : write map
	
	printf("phase6 : write map\n");
	for(i=0;i<data_count;i++){
		y[i]=19-y[i];
		printf("%d	%d	%d\n",num[i],x[i],y[i]);
		map[y[i]][x[i]]=num[i]+48;
	}
	
	
	printf("\n");
	//phase7 : write distance
	
	printf("phase7 : write distance\n");
	for(i=0;i<data_count;i++){
		draw_zone(DIS_W, i, FIELD);
	}
	for(i=0;i<data_count;i++){
		draw_zone(POST_R, i, SHELL);
	}
	for(i=0;i<data_count;i++){
		map[y[i]][x[i]]=num[i]+48;
	}
	
	draw_map(fname);
	return 0;
}

int draw_map(char name[]){
	int i,j;
	
	FILE *mf;
	
	if((mf=fopen(name,"w"))==NULL){
		printf("%s cannot open !\n",name);
		exit(1);
	}

	
	for(i=0;i<20;i++){
		if(i==10){
			for(j=0;j<21;j++){
				printf("= ");
				fprintf(mf,"= ");
			}
			printf("\n");
			fprintf(mf,"\n");
		}
		for(j=0;j<20;j++){
			if(j==10){
				printf("| ");
				fprintf(mf,"| ");
			}
			printf("%c ",map[i][j]);
			fprintf(mf,"%c ",map[i][j]);
		}
		printf("\n");
		fprintf(mf,"\n");
	}
	
	fclose(mf);
	return 0;
}
